import sys

def OPTJoeStuff( vsv, OPT):

## > >   (5) Do you want to reify the names of people?  YES!

## To make it possible to reify names:

##    In the TMA disclosure:

##      Create an SIP class whose name is "Name":

##        Disclose that proxies that have instances of this property
##        class will merge if the values of their instances of this
##        property class are the same.  See JacksTMA/tmaconf.xml
    
##        Disclose that when instances of this property are merged into a
##        single instance, any one of the original values becomes the
##        value of the new single property instance.  See JacksTMA/tmaconf.xml

##        Etc.

## To reify the name "Joe" in the subject map:

##      Create a proxy for the name "Joe".

    proxyForTheNameJoe = vsv.newProxyObject()

##      Add an instance of the "Name" property class to that proxy.
##      Make its value "Joe".

    vsv.newPropertyInstance( 
	proxyForTheNameJoe,
        'JacksTMA',
        'Name',
        'Joe')

## > >   (I assume you want to reify Joe, so I won't ask about that.)

## To make it possible to reify persons:

##    In the TMA disclosure:

##      Create an SIP class whose name is "Person Name Proxy":

##        Disclose that proxies that have instances of this property
##        class will merge if the values of their instances of this
##        property class are the same.  See JacksTMA/tmaconf.xml
    
##        Disclose that when instances of this property are merged into a
##        single instance, any one of the original values becomes the
##        value of the new single property instance.  See JacksTMA/tmaconf.xml

##        Etc.

## To reify Joe in the subject map:

##      Create a proxy for Joe.

    proxyForJoe = vsv.newProxyObject()
    

##      Add an instance of the "Person Name Proxy" property class to that proxy.
##      Make its value the proxy whose subject is the name "Joe".  

    vsv.newPropertyInstance( 
	proxyForJoe,
        'JacksTMA',
        'Person Name Proxy',
        [ proxyForTheNameJoe.proxyId])

##      Discussion: Here's another case of theory vs. practice.  In
##                  theory, the value of the "Person Name Proxy" property
##                  is the proxy whose subject is the name "Joe".  In
##                  practice, the value is a reference to that proxy.

## > >   (6) Do you want to reify the relationships between people and their
## > >       names?  YES!

## First of all, to make it possible to reify relationships:

##    Declare that your subject map is governed by a TMA for the
##    reification of relationships.  Let's assume it's the one in the
##    TMA plan I've attached to this note.

##  (see parkdemo.py, where it says:
##  vsv.loadTMA( tmName, 'BigAssert', '${VSVEXECDIR}/Lib/BIGASSERT/tmaconf.xml')

## To allow relationships between persons and their names to be reified:

##    Create a proxy for the "namedPerson" role of all
##    namedPerson-nameOfPerson relationships.  (You'll need an SIP class
##    for that, but I'm not going to go into that detail here.  Nor am I
##    bothering to specify, in this note, the SIPs of any of the other
##    role topics.  You might want to use yet another TMA, one that's for
##    the purpose of reifying roles in relationships, to facilitate that.
##    Or you may want to do that in your own peculiar way, either as an
##    independent TMA or as part of this TMA.  Or you might want to have
##    a bunch of TMAs for reifying various roles.)

##  (see parkdemo.py, where it says:
##  vsv.loadTMA( tmName, 'Roles',     '${VSVEXECDIR}/Lib/ROLES/tmaconf.xml')
##  This is a very simple TMA for reifying subjects that are roles.

    proxyForTheNamedPersonRole = vsv.newProxyObject()

    vsv.newPropertyInstance( 
	proxyForTheNamedPersonRole,
        'Roles',
        'role name',
        'namedPerson')

##    Create a proxy for the "nameOfPerson" role of all
##    namedPerson-nameOfPerson relationships.

    proxyForTheNameOfPersonRole = vsv.newProxyObject()

    vsv.newPropertyInstance( 
	proxyForTheNameOfPersonRole,
        'Roles',
        'role name',
        'nameOfPerson')

## To reify the relationship between the proxy for Joe and the name
## "Joe":

##    Create a proxy for the relationship between Joe and the name "Joe".

    proxyForRelationshipBetweenJoeAndHisName = vsv.newProxyObject()

##    Add an instance of the a-sip property class (see attachments to
##    this note) to the proxy for the relationship between Joe and the
##    name "Joe".  Make its value the following list of two tuples:

##      ( [ reference to the proxy for the "namedPerson" role ],
##        [ reference to the proxy for Joe] )
##      ( [ reference to the proxy for the "nameOfPerson" role ],
##        [ reference to the proxy for name "Joe" ] )

    vsv.newPropertyInstance( 
	proxyForRelationshipBetweenJoeAndHisName,
        'BigAssert',
        'a_sip',
        [ ( proxyForTheNamedPersonRole.proxyId, proxyForJoe.proxyId),
          ( proxyForTheNameOfPersonRole.proxyId, proxyForTheNameJoe.proxyId) ])


### merge test: Make another assertion just like the above, to check
### that the BIGASSERT TMA does its job.
    proxyForRelationshipBetweenJoeAndHisName2 = vsv.newProxyObject()
    vsv.newPropertyInstance( 
	proxyForRelationshipBetweenJoeAndHisName2,
        'BigAssert',
        'a_sip',
        [ ( proxyForTheNamedPersonRole.proxyId, proxyForJoe.proxyId),
          ( proxyForTheNameOfPersonRole.proxyId, proxyForTheNameJoe.proxyId) ])
### end merge test


##    Note: Because of the conferral rules in the assertion TMA described
##          in the attachments hereto, that's all you have to do.  The
##          c-proxies, the t-proxy, and all the rest of the necessary
##          assertion properties and property value components will be
##          conferred into existence automagically.

## > >   (1) Do you want to reify shoe sizes?  YES!

## To make it possible reify shoe sizes:

##    In the TMA disclosure:

##      Create an SIP class whose name is "Shoe Size".

##        Disclose that proxies that have instances of this property
##        class will merge if the values of their instances of this
##        property class are the same.  See JacksTMA/tmaconf.xml.
    
##        Disclose that when instances of this property are merged into a
##        single instance, any one of the original values becomes the
##        value of the new single property instance.  See JacksTMA/tmaconf.xml.

##        Etc.

## To reify the shoe size "6" in the subject map:

##      Create a proxy for shoe size "6".

    proxyForShoeSize6 = vsv.newProxyObject()

##      Add an instance of the "Shoe Size" property class to that proxy.
##      Make its value "6".  

    vsv.newPropertyInstance( 
	proxyForShoeSize6,
        'JacksTMA',
        'Shoe Size',
        '6')

## > >   (2) Do you want to reify ages?  YES!

## To make it possible to reify ages:

##    In the TMA disclosure:

##      Create an SIP class whose name is "Age".

##        Disclose that proxies that have instances of this property
##        class will merge if the values of their instances of this
##        property class are the same.  See JacksTMA/tmaconf.xml.
    
##        Disclose that when instances of this property are merged into a
##        single instance, any one of the original values becomes the
##        value of the new single property instance.  See JacksTMA/tmaconf.xml.

##        Etc.

## To reify age 7 in the subject map:

##      Create a proxy for age 7.

    proxyForAge7 = vsv.newProxyObject()

##      Add an instance of the "Age" property class to that proxy.
##      Make its value "7".  

    vsv.newPropertyInstance( 
	proxyForAge7,
        'JacksTMA',
        'Age',
        '7')
    

## > >   (4) Do you want to reify the relationships between shoe sizes and
## > >       the ages at which they were observed?  YES!

## To allow relationships between shoe sizes and the ages at which
## they were observed to be reified:

##    Create a proxy for the "shoeSizeObservation" role of all
##    shoeSizeObservation-ageAtShoeSizeObservation relationships.

    proxyForTheShoeSizeObservationRole = vsv.newProxyObject()

    vsv.newPropertyInstance( 
	proxyForTheShoeSizeObservationRole,
        'Roles',
        'role name',
        'shoeSizeObservation')

##    Create a proxy for the "ageAtShoeSizeObservation" role of all
##    shoeSizeObservation-ageAtShoeSizeObservation relationships.

    proxyForTheAgeAtShoeSizeObservationRole = vsv.newProxyObject()

    vsv.newPropertyInstance( 
	proxyForTheAgeAtShoeSizeObservationRole,
        'Roles',
        'role name',
        'ageAtShoeSizeObservation')

## To reify the relationship between Joe's shoe size and his age
## at the time at which his shoe size was observed:

##    Create a proxy for the relationship between Joe's shoe-size and the
##    age (7 years old) at which his shoe size was observed.

    proxyForRelationshipBetweenJoesShoeSizeAndHisAgeAtObservation = vsv.newProxyObject()

##    Add an instance of the a-sip property class (see attachments to
##    this note) to the proxy for the relationship between Joe's
##    shoe-size and the age at which his shoe size was observed.  Make
##    its value the following list of two tuples:

##      ( [ reference to the proxy for the "shoeSizeObservation" role ],
##        [ reference to the proxy for Joe's shoe size] )
##      ( [ reference to the proxy for the "ageAtShoeSizeObservation" role ],
##        [ reference to the proxy for the age of 7 ] )

    vsv.newPropertyInstance( 
	proxyForRelationshipBetweenJoesShoeSizeAndHisAgeAtObservation,
        'BigAssert',
        'a_sip',
        [ ( proxyForTheShoeSizeObservationRole.proxyId, proxyForShoeSize6.proxyId),
          ( proxyForTheAgeAtShoeSizeObservationRole.proxyId, proxyForAge7.proxyId) ])

## > >   (3) Do you want to reify the relationships between shoe sizes and
## > >       the people who have them?  YES!

## To allow relationships between persons and their shoe size at some specific
## age to be reified:

##    Create a proxy for the "personWithFeet" role of all
##    personWithFeet-observedShoeSize relationships.

    proxyForThePersonWithFeetRole = vsv.newProxyObject()

    vsv.newPropertyInstance( 
	proxyForThePersonWithFeetRole,
        'Roles',
        'role name',
        'PersonWithFeet')

##    Create a proxy for the "observedShoeSize" role of all
##    personWithFeet-observedShoeSize relationships.

    proxyForTheObservedShoeSizeRole = vsv.newProxyObject()

    vsv.newPropertyInstance( 
	proxyForTheObservedShoeSizeRole,
        'Roles',
        'role name',
        'ObservedShoeSize')

## To reify the relationship between Joe and his shoe size as observed at
## age 7, in the subject map:

##    Create a proxy for an instance of a personWithFeet-observedShoeSize
##    relationship.

    proxyForRelationshipBetweenJoeAndHisObservedShoeSize = vsv.newProxyObject()

##    Add an instance of the a-sip property class (see attachments to
##    this note) to the proxy for the instance of the personWithFeet-observedShoeSize
##    relationship.  Make its value the following list of two tuples:

##      ( [ reference to the proxy for the "personWithFeet" role ],
##        [ reference to the proxy for Joe] )
##      ( [ reference to the proxy for the "observedShoeSize role ],
##        [ reference to the proxy for the relationship between Joe's
##          shoe-size and the age (7 years old) at which his shoe size
##          was observed ] )

    vsv.newPropertyInstance( 
	proxyForRelationshipBetweenJoeAndHisObservedShoeSize,
        'BigAssert',
        'a_sip',
        [ ( proxyForThePersonWithFeetRole.proxyId, proxyForJoe.proxyId),
          ( proxyForTheObservedShoeSizeRole.proxyId, proxyForRelationshipBetweenJoesShoeSizeAndHisAgeAtObservation.proxyId) ])

